#!/bin/bash
rfile='/etc/udev/rules.d/1008-bluetoothctrl.rules'

delete_bluetooth_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

case $1 in
	"add")
		echo "execute add $2"
		delete_bluetooth_rule
		case $2 in
			"enable") 
				rule='SUBSYSTEM=="bluetooth",RUN+="/usr/sbin/rfkill unblock bluetooth"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				rule='SUBSYSTEM=="bluetooth",RUN+="/usr/sbin/rfkill block bluetooth"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_bluetooth_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac