rfile='/etc/udev/rules.d/1002-cdromctrl.rules'
bfile='/etc/udev/rules.d/srunbind.ids'

delete_cdrom_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

sort_unbind_ids(){
	sort -u -o $bfile $bfile
}

case $1 in
	"add")
		echo "execute add $2"
		delete_cdrom_rule
		sort_unbind_ids
		case $2 in
			"enable") 
				while read line; do
				# 去除行尾的换行符
				line=$(echo $line | tr -d '\n')
				echo $line > /sys/bus/scsi/drivers/sr/bind
				done < "$bfile"
				rule='SUBSYSTEM=="block",KERNEL=="sr[0-9]*|vdisk*|xvd*",RUN+=""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				recordcmd='SUBSYSTEM=="scsi",DRIVERS=="sr",RUN+="/bin/sh -c \"echo $(basename $devpath) >> /etc/udev/rules.d/srunbind.ids\""'
				unbindcmd=',RUN+="/bin/sh -c \"echo $(basename $devpath) > /sys/bus/scsi/drivers/sr/unbind\""'
				rule=$recordcmd$unbindcmd
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			"readonly")
				rule='SUBSYSTEM=="block",KERNEL=="sr[0-9]*|vdisk*|xvd*",RUN+="/usr/bin/cdrom_readonly.sh"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $4"
			;;
		esac

	;;
	"delete")
		delete_cdrom_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac