#!/bin/bash
rfile='/etc/udev/rules.d/1015-imagectrl.rules'

delete_image_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

case $1 in
	"add")
		echo "execute add $2"
		delete_image_rule
		case $2 in
			"enable") 
				rule='SUBSYSTEM=="usb",ATTR{bInterfaceClass}=="06",ATTR{authorized}="1"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				rule='SUBSYSTEM=="usb",ATTR{bInterfaceClass}=="06",ATTR{authorized}="0"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_image_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac