#!/bin/bash
rfile='/etc/udev/rules.d/1009-irdactrl.rules'

delete_irda_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

case $1 in
	"add")
		echo "execute add $2"
		delete_irda_rule
		case $2 in
			"enable") 
				rule='SUBSYSTEM=="irda",ATTR{enable}="1"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				rule='SUBSYSTEM=="irda",ATTR{enable}="0"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_irda_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac