#!/bin/bash
rfile='/etc/udev/rules.d/1005-parportctrl.rules'
bfile='/etc/udev/rules.d/unbind.ids'

delete_parport_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

sort_unbind_ids(){
	sort -u -o $bfile $bfile
}

case $1 in
	"add")
		echo "execute add $2"
		delete_parport_rule
		sort_unbind_ids 
		case $2 in
			"enable") 
				while read line; do
				# 判断当前行是否以"parport"开头
				if [[ $line =~ ^parport[0-9]+ ]]; then
					# 提取设备ID，并赋值给变量
					device_id=$(echo $line | awk '{print $2}')
					# 重新bind
					echo $device_id > /sys/bus/pnp/drivers/parport_pc/bind
				fi
				done < "$bfile"
				#parport0解绑driver后设备节点会消失,udev无法匹配相应节点
				
				head='SUBSYSTEM=="ppdev",KERNEL=="parport[0-9]*",RUN+='
				idgetcmdhead='"/bin/sh -c \"echo $(grep $kernel /etc/udev/rules.d/unbind.ids | awk '
				idgetcmdbody1="'{print "
				idgetcmdbody2='$2'
				idgetcmdbody3="}') "
				end='> /sys/bus/pnp/drivers/parport_pc/bind\""'
				rule=$head$idgetcmdhead$idgetcmdbody1$idgetcmdbody2$idgetcmdbody3$end
				#rule='SUBSYSTEM=="ppdev",RUN+="/bin/sh -c \"echo $(grep $kernel /etc/udev/rules.d/unbind.ids | awk '{print $2}')  > /sys/bus/pnp/drivers/parport_pc/bind\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
				
			;;

			"disable")
				head='SUBSYSTEM=="ppdev", KERNEL=="parport[0-9]*",RUN+='
				recordcmdhead='"/bin/sh -c \"echo $devpath | sed -e '
				recordcmdbody="'s|.*/\([0-9][0-9]:[0-9][0-9]\)/ppdev/\(.*\)|\2 \1|'"
				recordcmdend='>> /etc/udev/rules.d/unbind.ids\"\""'
				recordcmd=$recordcmdhead$recordcmdbody$recordcmdend
				unbindcmd=',RUN+="/bin/sh -c \"echo $devpath | rev | cut -d / -f 3 | rev > /sys/bus/pnp/drivers/parport_pc/unbind\""'
				rule=$head$recordcmd$unbindcmd
				#rule=SUBSYSTEM=="ppdev", KERNEL=="parport[0-9]*",RUN+="/bin/sh -c \"echo $devpath | sed -e 's|.*/\([0-9][0-9]:[0-9][0-9]\)/ppdev/\(.*\)|\2 \1|' >> /etc/udev/rules.d/unbind.ids\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_parport_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac