#!/bin/bash
rfile='/etc/udev/rules.d/1007-printerctrl.rules'

delete_printer_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

case $1 in
	"add")
		echo "execute add $2"
		delete_printer_rule
		case $2 in
			"enable") 
				rule='SUBSYSTEM=="usb", ATTRS{bInterfaceClass}=="07",RUN+="/bin/sh -c \"echo 1 > /sys/$DEVPATH/authorized\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				rule='SUBSYSTEM=="usb", ATTRS{bInterfaceClass}=="07",RUN+="/bin/sh -c \"echo 0 > /sys/$DEVPATH/authorized\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_printer_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac