#!/bin/bash
rfile='/etc/udev/rules.d/1012-scsiraidctrl.rules'

delete_scsiraid_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

case $1 in
	"add")
		echo "execute add $2"
		delete_scsiraid_rule
		case $2 in
			"enable") 
				rule='ACTION=="add",KERNEL=="scsi*",SUBSYSTEM=="scsi",ATTR{state}=="running"'
				echo $rule >> $rfile
				rule='ACTION=="add",KERNEL=="md*",SUBSYSTEM=="block",ATTR{md/degraded}="0"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				rule='ACTION=="add",KERNEL=="scsi*",SUBSYSTEM=="scsi",ATTR{state}=="offline"'
				echo $rule >> $rfile
				rule='ACTION=="add",KERNEL=="md*",SUBSYSTEM=="block",ATTR{md/degraded}="1"'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_scsiraid_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac