#!/bin/bash
rfile='/etc/udev/rules.d/1004-ttySctrl.rules'
bfile='/etc/udev/rules.d/unbind.ids'

delete_tty_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

sort_unbind_ids(){
	sort -u -o $bfile $bfile
}

case $1 in
	"add")
		echo "execute add $2"
		delete_tty_rule
		sort_unbind_ids 
		case $2 in
			"enable") 
				head='SUBSYSTEM=="tty", KERNEL=="ttyS[0-9]*",RUN+='
				idgetcmdhead='"/bin/sh -c \"echo $(grep $kernel /etc/udev/rules.d/unbind.ids | awk '
				idgetcmdbody1="'{print "
				idgetcmdbody2='$2'
				idgetcmdbody3="}') "
				end='> /sys/bus/pnp/drivers/serial/bind\""'
				rule=$head$idgetcmdhead$idgetcmdbody1$idgetcmdbody2$idgetcmdbody3$end
				#rule='SUBSYSTEM=="tty", KERNEL=="ttyS[0-9]*",RUN+="/bin/sh -c \"echo $(grep $kernel /etc/udev/rules.d/unbind.ids | awk '{print $2}'')  > /sys/bus/pnp/drivers/serial/bind\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				head='SUBSYSTEM=="tty", KERNEL=="ttyS[0-9]*",RUN+='
				recordcmdhead='"/bin/sh -c \"echo $devpath | sed -e '
				recordcmdbody="'s|.*/\([0-9][0-9]:[0-9][0-9]\)/tty/\(.*\)|\2 \1|'"
				recordcmdend='>> /etc/udev/rules.d/unbind.ids\"\""'
				recordcmd=$recordcmdhead$recordcmdbody$recordcmdend
				unbindcmd=',RUN+="/bin/sh -c \"echo $devpath | rev | cut -d / -f 3 | rev > /sys/bus/pnp/drivers/serial/unbind\""'
				rule=$head$recordcmd$unbindcmd
				#rule=SUBSYSTEM=="tty", KERNEL=="ttyS[0-9]*",RUN+="/bin/sh -c \"echo $devpath | sed -e 's|.*/\([0-9][0-9]:[0-9][0-9]\)/tty/\(.*\)|\2 \1|' >> /etc/udev/rules.d/unbind.ids\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_tty_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac