rfile='/etc/udev/rules.d/1001-ucctrl.rules'

delete_uc_rule() {
	pattern="SUBSYSTEM==.usb.,ATTR{bInterfaceClass}==.$1."
	echo $pattern
	sed -i "/$pattern/d" $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

case $1 in
	"add")
		echo "execute add $3"
		delete_uc_rule $2 
		case $3 in
			"enable") 
				rule='SUBSYSTEM=="usb",ATTR{bInterfaceClass}=="'$2'",ENV{USB_FREE}!="1",RUN+="/bin/sh -c \"echo $devpath | rev | cut -d / -f 2 | rev > /sys/bus/usb/drivers/usb/bind \""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				rule='SUBSYSTEM=="usb",ATTR{bInterfaceClass}=="'$2'",ENV{USB_FREE}!="1",RUN+="/bin/sh -c \"echo $devpath | rev | cut -d / -f 2 | rev > /sys/bus/usb/drivers/usb/unbind \""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			"readonly")
				rule='SUBSYSTEM=="usb",ATTR{bInterfaceClass}=="'$2'",ENV{USB_FREE}!="1",MODE="0666", RUN+="/bin/sh -c \"echo $kernel $devpath > /public/5\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $3" 
			;;
		esac

	;;
	"delete")
		delete_uc_rule $2 
	;;
	*)
		rule='SUBSYSTEM=="usb", RUN+="/bin/sh -c \"echo kernel=kernel devpath=devpath bDeviceClass=attr(bDeviceClass) > /public/1\""'
		echo $rule
		echo $rule >> $rfile
		udevadm control --reload-rules
		udevadm trigger
	;;
esac
