#!/bin/bash
rfile='/etc/udev/rules.d/1013-wincectrl.rules'

delete_wince_rule() {
	> $rfile
	echo 'execute delete'
	udevadm control --reload-rules
	udevadm trigger
}

case $1 in
	"add")
		echo "execute add $2"
		delete_wince_rule
		case $2 in
			"enable") 
				rule='SUBSYSTEM=="usb",ENV{ID_SERIAL_SHORT}=="WinCE*",RUN+="/bin/sh -c \"echo 1 > /sys/bus/usb/devices/%k/authorized\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;

			"disable")
				rule='SUBSYSTEM=="usb",ENV{ID_SERIAL_SHORT}=="WinCE*",RUN+="/bin/sh -c \"echo 0 > /sys/bus/usb/devices/%k/authorized\""'
				echo $rule >> $rfile
				udevadm control --reload-rules
				udevadm trigger
			;;
			*)
				echo "invalid op: $2"
			;;
		esac

	;;
	"delete")
		delete_wince_rule
	;;
	*)
		echo "invalid command $1"
	;;
esac